	.include	'jaguar.inc'

	.extern VideoIni
	.extern	IntInit
	.extern Lister
	.extern BlitLine
	.extern Clear
	.extern Mandle
	.extern end

	.globl	listbuf
	.globl	stopobj

	.globl	vid_on

PATTERN		equ	$20000

.text
; Run the GPU/BLIT interface in CORRECT mode ALWAYS
	move.l	#$00070007,G_END

; At this point we don't know what state the video is in
; It may be active or not and may be using an interrupt or not
; Since we may not turn video off we use the following procedure
; Disable VI by setting to a VERY large number.
;	The existing screen will fail to be refreshed so all bit maps vanish
; Set up an object list consisting of a stop object.
; Clear the spot the screen will be
; Set up the desired object list
; Set up an interrupt and start
; Set up the size of borders
; Point the Object Processor at the real object list
; Set VMODE to the desired resolution and color model

; NOTE: To blank the screen point the object processor at a stop object



	move.l	#$200000,a7		; Put the stack at the top of DRAM

	move.w	#$FFFF,VI		; Guarantee NO VI interrupts

	move.l	#0,stopobj
	move.l	#4,stopobj+4

	move.l	#stopobj,d0
	swap	d0
	move.l	d0,OLP			; Set up object processor to SAFE stop object!!!!

	jsr	Clear

	jsr	Lister

	jsr	IntInit

	jsr	VideoIni

	move.l	d5,OLP			; This is setup by Lister

vid_on:
	move.w	#$6C1,VMODE		; Set 16 bit CRY; 320 overscanned

	move.l	#0,G_CTRL		; Make sure the GPU is stopped

; Copy over the GPU program
	move.l	#end,a0
	move.l	(a0)+,a1		; Read starting address
	move.l	(a0)+,d0
	asr.l	#2,d0
loop:	move.l	(a0)+,(a1)+
	dbra	d0,loop

; Copy the palette into the chip

	move.l	#256,d0
	move.l	#CLUT,a0
	move.l	#cry_data,a1

cloop:	move.w	(a1)+,(a0)+
	dbra	d0,cloop

	jsr	Mandle

	illegal

.bss
.phrase
listbuf:	ds.l	16

.phrase
stopobj:
		ds.l	2

		
.data
; This file has a label cry_data that has, in 68k format the top level of cry for 8 bits
	.include "cry.pal"

